// power by FA 2017.5.12
//update 2017.6.3
// 动态设定 根html的font-size达到动态适应屏幕宽度的目的

(function(){
  var pageWidth = 720;
  // 设定屏幕几等分 然后用设计稿里面元素的宽和高分别除以设计稿的宽和高得到对应的比例 然后乘以 几等分 = 最终的rem的大小
  // 这个rem的大小设定好之后 几乎所有的设备都是按照相同的比例进行方法和缩小 基本可以按照比例精确到1-2px
  // 但是此方法难点在于 设计稿的尺寸量取 和 rem的数值计算 精确 = 时间
  var html = document.getElementsByTagName('html')[0];
  html.style.fontSize = pageWidth / 15 + 'px';
}())
